// -*-java-*-
// $Id: geotude.js,v 1.6 2007/08/18 16:14:18 asc Exp $

// http://www.aaronland.info/javascript/geotude/
// http://www.aaronland.info/weblog/2007/07/28/trees/#delmaps

// Copyright (c) 2007 Aaron Straup Cope. All Rights Reserved.
// This is free software, you may use it and distribute it under the
// same terms as Perl itself.

// Reference :
// http://www.geotude.com/main/formula

function Geotude (args) {
	this._geotude = new Array();
	this._latlon = new Array();

	if (args['geotude']){
            this._geotude = this.geotude_split(args['geotude']);
	}

	if ((args['latitude']) && (args['longitude'])){
		this._latlon.push(args['latitude']);
		this._latlon.push(args['longitude']);
	}
}

Geotude.prototype.geotude = function(){
	if (this._geotude.length==0){
		this._geotude = this.point2geotude(this._latlon[0], this._latlon[1]);
	}

	return this._geotude;
};

Geotude.prototype.point = function(){
	if (this._latlon.length==0){
		this._latlon = this.geotude2point(this._geotude.join("."));
	}

	return this._latlon;
};

Geotude.prototype.geotude2point = function(geotude){
	latlon = new Array();
	parts  = this.geotude_split(geotude);

	major = parts[0];
	minors = String(parts[1]).split(".");

	gt = major - 10000;

	lat_dec = "";
	lon_dec = "";

	for (var i in minors){
		mnr = String(minors[i]).split("");
		lat_dec += mnr[0];
		lon_dec += mnr[1];
	}

	lat_foo = Math.floor((gt - gt % 500) / 500);
	lon_foo = Math.floor(gt % 500);

	lat = parseFloat(lat_foo + "." + lat_dec);
	lon = parseFloat(lon_foo + "." + lon_dec);

        prec = lat_dec.length;

        lat = 90 - lat;
        lat = lat.toFixed(prec);

        lon = lon - 180;
        lon = lon.toFixed(prec);

	latlon.push(lat);
	latlon.push(lon);

	return latlon;
};

Geotude.prototype.point2geotude = function(lat, lon){

	geotude = new Array();

	lat_major = 90 - Number(lat);
        lon_major = 180 + Number(lon);

        parts_lat = String(lat_major).split(".");
        parts_lon = String(lon_major).split(".");

        lat_minor = parts_lat[1];
        lon_minor = parts_lon[1];

	gt_major = 500 * Math.floor(lat_major) + Math.floor(lon_major) + 10000;
	gt_minor = new Array();

	len = Math.min(lat_minor.length, lon_minor.length);

	for (var i=0; i < len; i++){
		str_minor  = lat_minor[i];
		str_minor += lon_minor[i];
                gt_minor.push(str_minor);
	}

	geotude.push(gt_major);
	geotude.push(gt_minor.join("."));

	return geotude;
};

Geotude.prototype.geotude_split = function(gt){

    	var parts = new Array();
	var re = new RegExp(/^(\d+)\.(.*)$/);

	if (m = re.exec(gt)){
		parts.push(m[1]);
		parts.push(m[2]);
	}
        
        return parts;
};
